'XWORD.BAS
'May 2000 by Marc Kummel aka Treebeard.
'Contact mkummel@rain.org, http://www.rain.org/~mkummel/

'Take a list of words and try to fit them into the smallest
'possible nxn crossword.
'My project for the DMS Science Fair 12 May 2000.
'-------------------------------------------------------------------------
  CONST ver = "v.22, 20 May 00"

  DECLARE SUB BottomLine (msg$)
  DECLARE SUB BottomMsg (msg$)
  DECLARE SUB ClearGrid ()
  DECLARE SUB ClearWindow ()
  DECLARE SUB ClearWordWindow ()
  DECLARE SUB ClockReset ()
  DECLARE SUB ClockRestart ()
  DECLARE SUB ClockStop ()
  DECLARE SUB CountLetters ()
  DECLARE SUB InputGridSize ()
  DECLARE SUB InputWordList (flag%)
  DECLARE SUB LoadGrid ()
  DECLARE SUB MakeXword ()
  DECLARE SUB NewGridSize ()
  DECLARE SUB NewSettings ()
  DECLARE SUB NewWordGrid ()
  DECLARE SUB NewWordList ()
  DECLARE SUB OtherDirection (dr%)
  DECLARE SUB PickWord (row%, col%, direction%, index%)
  DECLARE SUB PlaceWord (row%, col%, direction%, index%)
  DECLARE SUB QSort (array$(), start%, finish%)
  DECLARE SUB QSortScore ()
  DECLARE SUB ReadWordList (filename$)
  DECLARE SUB SaveBestGrid (try&, words%, letters%, connections%, runtime!)
  DECLARE SUB SaveGrid (deviceflag%)
  DECLARE SUB SaveHTML ()
  DECLARE SUB SaveMinGrid (try&, words%, letters%, connections%, runtime!)
  DECLARE SUB ScoreWords ()
  DECLARE SUB ScoreGrid (words%, letters%, connections%)
  DECLARE SUB ShowBestGrid ()
  DECLARE SUB ShowInfo ()
  DECLARE SUB ShowStats (msg$, row%, try&, words%, letters%, connections%, runtime!)
  DECLARE SUB ShowWord (index%)
  DECLARE SUB ShowWordAdjust (dif%)
  DECLARE SUB ShowMinGrid ()
  DECLARE SUB ShowNewGrid ()
  DECLARE SUB SizeScreen (screenheight%)
  DECLARE SUB SoundBeep ()
  DECLARE SUB SoundBop ()
  DECLARE SUB XWordLoop (flag%)

  DECLARE FUNCTION ClockRunTime! ()
  DECLARE FUNCTION ClockStopTime! ()
  DECLARE FUNCTION ClockTimeStr$ (t!)
  DECLARE FUNCTION FindDirection% (row%, col%)
  DECLARE FUNCTION FindWord% (row%, col%, direction%, index%, srow%, scol%)
  DECLARE FUNCTION FindWord2% (row%, col%, direction%, index%, srow%, scol%)
  DECLARE FUNCTION GetKey% ()

  'useful stuff
  CONST false = 0, true = NOT false, nada = -1
  CONST black = 0, blue = 1, green = 2, cyan = 3, red = 4, magenta = 5
  CONST brown = 6, white = 7, gray = 8, lightblue = 9, lightgreen = 10
  CONST lightcyan = 11, lightred = 12, lightmagenta = 13, yellow = 14
  CONST hiwhite = 15

  CONST dotchar = 249
  CONST empty = 0
  CONST asca = 97, ascz = 122
  CONST across = 0, down = 1            'orientation on grid
  CONST mingridsize = 10                'smallest grid
  CONST maxgridsize = 46                'biggest grid
  CONST startrow = 2                    'where to start grid display
  CONST startcol = 1

  'different exit flags from main loop
  CONST doneflag = 0
  CONST gridflag = 1
  CONST wordflag = 2

  'different algorithms for FindWord()
  CONST maxfind = 4
  CONST findfirst = 0
  CONST findshort = 1
  CONST findlong = 2
  CONST findmiddle = 3
  CONST findrandom = 4
  
  'different algorithms for MakeXword()
  CONST makefind = 0
  CONST makealternate = 1
  CONST makerandom = 2

  'deal with DOS special keys
  DIM SHARED enter$, esc$, null$, acs0$, q$
  DIM SHARED upkey$, downkey$, leftkey$, rightkey$
  DIM SHARED homekey$, endkey$, pgupkey$, pgdnkey$
  enter$ = CHR$(13)
  esc$ = CHR$(27)
  null$ = ""
  acs0$ = CHR$(0)
  q$ = CHR$(34)
  upkey$ = acs0$ + CHR$(72)
  downkey$ = acs0$ + CHR$(80)
  leftkey$ = acs0$ + CHR$(75)
  rightkey$ = acs0$ + CHR$(77)
  homekey$ = acs0$ + CHR$(71)
  endkey$ = acs0$ + CHR$(79)
  pgupkey$ = acs0$ + CHR$(73)
  pgdnkey$ = acs0$ + CHR$(81)
  
  'word list slider details
  DIM SHARED slide$, slidemark$, uparrow$, downarrow$
  slide$ = CHR$(177)
  slidemark$ = CHR$(219)
  uparrow$ = CHR$(24)
  downarrow$ = CHR$(25)

  'main menu
  'menu$ = "<Spc>=more <Q>uit <D>isplay <G>rid" + CHR$(241) + " <A>uto <P>rint <S>ave <W>ords <I>nfo <H>elp"

  lmenu$ = SPACE$(78)
  MID$(lmenu$, 1) = "<Spc>=more <Q>uit <D>isplay" + CHR$(241) + " <G>rid" + CHR$(241) + " <A>uto <P>rint <S>ave <W>ords <H>tml"
  MID$(lmenu$, 76) = "<->"

  rmenu$ = SPACE$(78)
  MID$(rmenu$, 1) = "<O>ptions <I>nfo <L>oad <X>step" + CHR$(241) + " <M>inimum <R>andomize"
  MID$(rmenu$, 76) = "<->"

  'menu$ = "<Q>uit <D>isplay <G>rid" + CHR$(241) + " <A>uto <P>rint <S>ave <W>ords <I>nfo <O>ptions <H>tml"
  menu$ = lmenu$

  'these effect how it looks
  maxgrid% = 21                         'New York Times sunday size
  consolflag% = false                   'only print results?
  displayflag% = true                   'show work in progress?
  bgcolorflag% = true                   'use BGCOLOR="black" for HTML grid

  'these effect how it works
  maketype% = makealternate             'algorithm for MakeXword()
  findtype% = findmiddle                'algorithm for FindWord2()
  midlength% = 6                        'preferred word lenth in FindWord2()
  rndfac! = .5                          'prob of starting in corner

  'debug flags, probably not useful
  singlestep% = false                   'single step through solutions?
  norandom% = false                     'set true to NOT randomize timer

  'default files
  savefile$ = "best"
  wordfile$ = "wordlist.txt"
  
  'fixed size arrays
  REDIM letter%(asca TO ascz)                   'count each letter in word list
  
  'array stubs, these depend on word list
  REDIM word$(0)           'word list (1-maxword%)
  REDIM wordasc%(0, 0)     'each word as ascii array
  REDIM wordlength%(0)     'word index by length
  REDIM wordscore%(0)      'score for letters in word list
  REDIM wordrc%(0, 0)      'row, col for each name display
  REDIM wordrs$(0)         'name (score) for each name
  REDIM used%(0)           'flag true if name already used
  REDIM bestused%(0)       'flag true if name used in bestgrid%()
  REDIM minused%(0)        'flag true if name used in mingrid%()
  REDIM sortscore%(0)      'sort word index by score

  'array stubs, these depend on grid size
  REDIM grid%(0, 0)        'the grid letter by letter
  REDIM bestgrid%(0, 0)    'the best grid (so far) letter by letter
  REDIM mingrid%(0, 0)     'the worst grid (so far) letter by letter

  'try to open default word list, or get input
  IF LEN(DIR$(wordfile$)) THEN
    'found file
  ELSE
    LINE INPUT "Xword word file: ", wordfile$
    wordfile$ = LTRIM$(RTRIM$(UCASE$(wordfile$)))
    flag% = false

    'see if file exists
    IF LEN(wordfile$) THEN
      IF INSTR(wordfile$, ".") = 0 THEN wordfile$ = wordfile$ + ".txt"
      IF LEN(DIR$(wordfile$)) THEN flag% = true
    END IF

    IF NOT flag% THEN
      PRINT "Can't open word file."
      END
    END IF
  END IF

  'Main loop, it all happens here
  flag% = false
  DO
    NewWordList
    DO
      NewSettings
      NewGridSize
      XWordLoop flag%
    LOOP WHILE flag% = gridflag
  LOOP WHILE flag% = wordflag
  
  'All done, polite exit
  IF screenheight% <> 25 THEN WIDTH 80, 25
  COLOR white, black
  CLS
END

SUB BottomLine (msg$)
  SHARED botline%

  n$ = SPACE$(79)
  MID$(n$, 2) = msg$
  COLOR white, blue
  LOCATE botline%, 1: PRINT n$;
  COLOR white, black

END SUB

SUB BottomMsg (msg$)
  BottomLine msg$
  in$ = INPUT$(1)
END SUB

SUB ClearGrid
  SHARED grid%(), used%()
  SHARED maxword%, maxgrid%
  SHARED maxgridrow%, maxgridcol%
  
  maxgridrow% = 0                                   'max occupied row
  maxgridcol% = 0                                   'max occupied column
  REDIM grid%(1 TO maxgrid%, 1 TO maxgrid%)
  REDIM used%(maxword%)

END SUB

'Clear screen except for logo, place cursor below
'
SUB ClearWindow
  SHARED maxgrid%

  ClearWordWindow
  FOR i% = 1 TO maxgrid%
    LOCATE i% + 2, 1: PRINT SPACE$(maxgrid% + 3);
  NEXT i%
  LOCATE 4, 1

END SUB

'Clear wordlist window on screen
'
SUB ClearWordWindow
  SHARED wordtoprow%, wordbotrow%
  SHARED wordstart%, wordwide%

  n$ = SPACE$(80 - wordstart% - 1)
  FOR row% = wordtoprow% TO wordbotrow%
    LOCATE row%, wordstart% - 1
    PRINT n$;
  NEXT row%

END SUB

'Clear elapsed time
'
SUB ClockReset
  SHARED etime!, stime!

  etime! = 0
  stime! = TIMER
  
END SUB

'Restart the clock after ClockStop
'
SUB ClockRestart
  SHARED stime!

  stime! = TIMER
END SUB

'Return elapsed time as real number of seconds
'ONLY works while clock is running!
'
FUNCTION ClockRunTime!
  SHARED etime!, stime!

  ClockRunTime! = etime! + (TIMER - stime!)

END FUNCTION

'Stop the clock, but can be restarted with ClockStart()
'
SUB ClockStop
  SHARED etime!, stime!

  etime! = etime! + TIMER - stime!
  stime! = 0

END SUB

'Return elapsed time as real number of seconds
'ONLY works while clock is stopped!
'
FUNCTION ClockStopTime!
  SHARED etime!

  ClockStopTime! = etime!

END FUNCTION

'Return elapsed time as a formatted string hr:min:sec
'
FUNCTION ClockTimeStr$ (runtime!)

  t! = runtime!
  hour% = t! \ 3600!
  t! = (t! - hour% * 60!)
  min% = t! \ 60!
  sec% = t! - min% * 60!
  ClockTimeStr$ = RIGHT$("0" + LTRIM$(STR$(hour%)), 2) + ":" + RIGHT$("0" + LTRIM$(STR$(min%)), 2) + ":" + RIGHT$("0" + LTRIM$(STR$(sec%)), 2)

END FUNCTION

'count all letters in all words in letter%()
'This could do other analyses to optimize methods
'
SUB CountLetters
  SHARED word$()
  SHARED wordlength%(), letter%(), wordasc%()
  SHARED maxword%, maxletter%
  SHARED wordavg!, wordstd!
  
  FOR i% = asca TO ascz
    letter%(i%) = 0
  NEXT i%

  FOR i% = 1 TO maxword%
    wordlength%(i%) = LEN(word$(i%))
    FOR j% = 1 TO wordlength%(i%)
      n% = ASC(MID$(word$(i%), j%, 1))
      letter%(n%) = letter%(n%) + 1
      wordasc%(i%, j%) = n%
    NEXT j%
  NEXT i%

  'find highest letter count
  maxletter% = 0
  FOR i% = asca TO ascz
    IF letter%(i%) > maxletter% THEN maxletter% = letter%(i%)
  NEXT i%

  'other statistics might be useful?
  wordavg! = 0          'mean word length
  wordstd! = 0          'standard deviation

  sumx! = 0
  sumx2! = 0
  FOR i% = 1 TO maxword%
    n! = CSNG(wordlength%(i%))
    wordavg! = wordavg! + n!
    sumx! = sumx! + n!
    sumx2! = sumx2! + (n! * n!)
  NEXT i%
  n! = CSNG(maxword%)
  wordavg! = wordavg! / n!
  wordstd! = SQR((n! * sumx2! - sumx! * sumx!) / (n! * (n! - 1!)))

END SUB

'Given a place on the grid, what way should new word go?
'Damn, this is important!
'
FUNCTION FindDirection% (row%, col%)
  SHARED grid%()
  SHARED maxgrid%

  'top row
  IF row% = 1 THEN

    'left corner
    IF col% = 1 THEN
      IF grid%(row%, col% + 1) = 0 THEN
        direction% = across
      ELSEIF grid%(row% + 1, col%) = 0 THEN
        direction% = down
      ELSE
        direction% = nada
      END IF

    'right corner
    ELSEIF col% = maxgrid% THEN
      IF grid%(row%, col% - 1) = 0 THEN
        direction% = across
      ELSEIF grid%(row% + 1, col%) = 0 THEN
        direction% = down
      ELSE
        direction% = nada
      END IF

    'in between
    ELSE
      IF grid%(row%, col% - 1) = 0 AND grid%(row%, col% + 1) = 0 THEN
        direction% = across
      ELSEIF grid%(row% + 1, col%) = 0 THEN
        direction% = down
      ELSE
        direction% = nada
      END IF
    END IF

  'bottom row
  ELSEIF row% = maxgrid% THEN

    'left corner
    IF col% = 1 THEN
      IF grid%(row%, col% + 1) = 0 THEN
        direction% = across
      ELSEIF grid%(row% - 1, col%) = 0 THEN
        direction% = down
      ELSE
        direction% = nada
      END IF

    'right corner
    ELSEIF col% = maxgrid% THEN
      IF grid%(row%, col% - 1) = 0 THEN
        direction% = across
      ELSEIF grid%(row% - 1, col%) = 0 THEN
        direction% = down
      ELSE
        direction% = nada
      END IF

    'in between
    ELSE
      IF grid%(row%, col% - 1) = 0 AND grid%(row%, col% + 1) = 0 THEN
        direction% = across
      ELSEIF grid%(row% - 1, col%) = 0 THEN
        direction% = down
      ELSE
        direction% = nada
      END IF
    END IF
  
  'left edge (not a corner)
  ELSEIF col% = 1 THEN
    IF grid%(row% - 1, col%) = 0 AND grid%(row% + 1, col%) = 0 THEN
      direction% = down
    ELSEIF grid%(row%, col% + 1) = 0 THEN
      direction% = across
    ELSE
      direction% = nada
    END IF

  'right edge (not a corner)
  ELSEIF col% = maxgrid% THEN
    IF grid%(row% - 1, col%) = 0 AND grid%(row% + 1, col%) = 0 THEN
      direction% = down
    ELSEIF grid%(row%, col% - 1) = 0 THEN
      direction% = across
    ELSE
      direction% = nada
    END IF
  
  'else we're in the middle
  ELSE

    'clear up/down?
    IF grid%(row% - 1, col%) = 0 AND grid%(row% + 1, col%) = 0 THEN
      direction% = down

    'clear across?
    ELSEIF grid%(row%, col% - 1) = 0 AND grid%(row%, col% + 1) = 0 THEN
      direction% = across

    'else nothing is clear
    ELSE
      direction% = nada
    END IF

  END IF

  FindDirection% = direction%

END FUNCTION

'Look for a word that fits, return with first match, which is high score.
'This is my first shot at the core routine, returns first word that fits.
'
FUNCTION FindWord% (row%, col%, direction%, index%, srow%, scol%)
  SHARED word$()
  SHARED wordlength%(), sortscore%(), wordasc%()
  SHARED grid%(), used%()
  SHARED maxword%, maxgrid%

  ch$ = CHR$(grid%(row%, col%))
  index% = nada
  gotmatch% = false

  'down
  IF direction% = down THEN
    FOR i% = maxword% TO 1 STEP -1
      IF NOT used%(sortscore%(i%)) THEN
        wdindex% = sortscore%(i%)
        wd$ = word$(wdindex%)
        wdlen% = LEN(wd$)

        spos% = 1
        chpos% = INSTR(spos%, wd$, ch$)

        DO WHILE chpos%
          flag% = false                 'true if word fails
          start% = row% - chpos% + 1    'start row of word in place

          IF start% < 1 OR start% + wdlen% - 1 > maxgrid% THEN
            'off the grid
            flag% = true:               'EXIT FOR

          ELSE
            'on the grid, see if it fits
            FOR j% = 1 TO wdlen%
              gridcell% = grid%(start% + j% - 1, col%)
              IF gridcell% = 0 THEN
                'cell is clear
              ELSE
                'cell matches word
                IF gridcell% <> wordasc%(wdindex%, j%) THEN flag% = true: EXIT FOR
              END IF
            NEXT j%
          END IF

          'word fits but there must also be blanks on the ends
          IF flag% = false THEN
            IF start% = 1 THEN
              IF grid%(start% + wdlen%, col%) <> 0 THEN flag% = true
            ELSEIF start% + wdlen% - 1 = maxgrid% THEN
              IF grid%(start% - 1, col%) <> 0 THEN flag% = true
            ELSEIF grid%(start% - 1, col%) <> 0 OR grid%(start% + wdlen%, col%) <> 0 THEN
              flag% = true
            END IF
          END IF

          'word fits but there might be llegal combos to left and right
          'need to exploit this to get really tight packings!
          IF flag% = false THEN
            FOR j% = 1 TO wdlen%
              IF j% <> chpos% THEN
                trow% = start% + j% - 1
                IF col% > 1 THEN
                  IF grid%(trow%, col% - 1) <> 0 THEN
                    flag% = true: EXIT FOR
                  END IF
                END IF
                IF col% < maxgrid% THEN
                  IF grid%(trow%, col% + 1) <> 0 THEN
                    flag% = true: EXIT FOR
                  END IF
                END IF
              END IF
            NEXT j%
          END IF

          IF flag% THEN
            'word doesn't fit, look or another match
            spos% = chpos% + 1
            chpos% = INSTR(spos%, wd$, ch$)
          ELSE
            'word fits, get out
            gotmatch% = true
            index% = wdindex%
            srow% = start%
            scol% = col%
            EXIT DO
          END IF
        LOOP

      END IF
      IF gotmatch% THEN EXIT FOR
      
    NEXT i%

  'across
  ELSE
    FOR i% = maxword% TO 1 STEP -1
      IF NOT used%(sortscore%(i%)) THEN
        wdindex% = sortscore%(i%)
        wd$ = word$(wdindex%)
        wdlen% = LEN(wd$)

        spos% = 1
        chpos% = INSTR(spos%, wd$, ch$)

        DO WHILE chpos%
          flag% = false                 'true if word fails
          start% = col% - chpos% + 1    'left edge

          IF start% < 1 OR start% + wdlen% - 1 > maxgrid% THEN
            'off the grid
            flag% = true:               'EXIT FOR

          ELSE
            'on the grid, see if it fits
            FOR j% = 1 TO wdlen%
              gridcell% = grid%(row%, start% + j% - 1)
              IF gridcell% = 0 THEN
                'ok
              ELSE
                IF gridcell% <> wordasc%(wdindex%, j%) THEN flag% = true: EXIT FOR
              END IF
            NEXT j%
          END IF
          
          'word fits but there must also be blanks on the ends
          IF flag% = false THEN
            IF start% = 1 THEN
              IF grid%(row%, start% + wdlen%) <> 0 THEN flag% = true
            ELSEIF start% + wdlen% - 1 = maxgrid% THEN
              IF grid%(row%, start% - 1) <> 0 THEN flag% = true
            ELSEIF grid%(row%, start% - 1) <> 0 OR grid%(row%, start% + wdlen%) <> 0 THEN
              flag% = true
            END IF
          END IF

          'word fits but there might be llegal combos above and below
          IF flag% = false THEN
            FOR j% = 1 TO wdlen%
              IF j% <> chpos% THEN
                tcol% = start% + j% - 1
                IF row% > 1 THEN
                  IF grid%(row% - 1, tcol%) <> 0 THEN
                    flag% = true: EXIT FOR
                  END IF
                END IF
                IF row% < maxgrid% THEN
                  IF grid%(row% + 1, tcol%) <> 0 THEN
                    flag% = true: EXIT FOR
                  END IF
                END IF
              END IF
            NEXT j%
          END IF

          IF flag% THEN
            spos% = chpos% + 1
            chpos% = INSTR(spos%, wd$, ch$)
          ELSE
            gotmatch% = true
            index% = wdindex%
            srow% = row%
            scol% = start%
            EXIT DO
          END IF
        LOOP

      END IF
      IF gotmatch% THEN EXIT FOR

    NEXT i%
    
  END IF

  FindWord% = gotmatch%
END FUNCTION

'Look for all words that fit, return with best.
'Try ALL words in all positions and score by how many letters match
'existing letters on grid AND word length findtype% fitness factor.
'
FUNCTION FindWord2% (row%, col%, direction%, index%, srow%, scol%)
  SHARED word$()
  SHARED wordlength%(), sortscore%(), wordasc%()
  SHARED grid%(), used%()
  SHARED maxword%, maxgrid%, findtype%, maxletter%, midlength%

  'used to keep track of each found word that fits
  '  matchinfo%(n,0)=index into word$()
  '  matchinfo%(n,1)=srow
  '  matchinfo%(n,2)=scol
  '  matchinfo%(n,3)=matches
  DIM matchinfo%(maxletter%, 3)
  matchindex% = 0

  'used to build list of best matches
  DIM hitlist%(maxletter%)

  'as is, can only find 1 character match
  ch$ = CHR$(grid%(row%, col%))
  
  'down
  IF direction% = down THEN
    FOR i% = maxword% TO 1 STEP -1              'high scores first
      IF NOT used%(sortscore%(i%)) THEN
        wdindex% = sortscore%(i%)
        wd$ = word$(wdindex%)
        wdlen% = LEN(wd$)

        spos% = 1
        chpos% = INSTR(spos%, wd$, ch$)

        DO WHILE chpos%
          flag% = false                 'true if word fails
          match% = 0                    'count matching letters
          start% = row% - chpos% + 1    'start row of word in place

          IF start% < 1 OR start% + wdlen% - 1 > maxgrid% THEN
            'off the grid
            flag% = true:               'EXIT FOR

          ELSE
            'on the grid, see if it fits
            FOR j% = 1 TO wdlen%
              gridcell% = grid%(start% + j% - 1, col%)

              IF gridcell% = 0 THEN
                'cell is clear
              ELSE
                'cell matches word
                IF gridcell% = wordasc%(wdindex%, j%) THEN
                  match% = match% + 1
                ELSE
                  'word doesn't fit
                  flag% = true: EXIT FOR
                END IF
              END IF
            NEXT j%
          END IF

          'word fits but there must also be blanks on the ends
          IF flag% = false THEN
            IF start% = 1 THEN
              IF grid%(start% + wdlen%, col%) <> 0 THEN flag% = true
            ELSEIF start% + wdlen% - 1 = maxgrid% THEN
              IF grid%(start% - 1, col%) <> 0 THEN flag% = true
            ELSEIF grid%(start% - 1, col%) <> 0 OR grid%(start% + wdlen%, col%) <> 0 THEN
              flag% = true
            END IF
          END IF

          'word fits but there might be llegal combos to left and right
          'need to exploit this to get really tight packings!
          IF flag% = false THEN
            FOR j% = 1 TO wdlen%
              IF j% <> chpos% THEN
                trow% = start% + j% - 1
                IF col% > 1 THEN
                  IF grid%(trow%, col% - 1) <> 0 THEN
                    flag% = true: EXIT FOR
                  END IF
                END IF
                IF col% < maxgrid% THEN
                  IF grid%(trow%, col% + 1) <> 0 THEN
                    flag% = true: EXIT FOR
                  END IF
                END IF
              END IF
            NEXT j%
          END IF

          'word fits here so save info
          IF flag% = false THEN
            srow% = start%
            scol% = col%
            GOSUB AddMatch
          END IF

          'keep searching, the same word might fit in another position
          spos% = chpos% + 1
          chpos% = INSTR(spos%, wd$, ch$)
        LOOP
      END IF
    NEXT i%

  'across
  ELSE
    FOR i% = maxword% TO 1 STEP -1
      IF NOT used%(sortscore%(i%)) THEN
        wdindex% = sortscore%(i%)
        wd$ = word$(wdindex%)
        wdlen% = LEN(wd$)

        spos% = 1
        chpos% = INSTR(spos%, wd$, ch$)

        DO WHILE chpos%
          flag% = false                 'true if word fails
          match% = 0                    'count matching letters
          start% = col% - chpos% + 1    'left edge

          IF start% < 1 OR start% + wdlen% - 1 > maxgrid% THEN
            'off the grid
            flag% = true:               'EXIT FOR

          ELSE
            'on the grid, see if it fits
            FOR j% = 1 TO wdlen%
              gridcell% = grid%(row%, start% + j% - 1)
              IF gridcell% = 0 THEN
                'cell is clear
              ELSE
                'cell matches word
                IF gridcell% = wordasc%(wdindex%, j%) THEN
                  match% = match% + 1
                ELSE
                  'word doesn't fit
                  flag% = true: EXIT FOR
                END IF
              END IF
            NEXT j%
          END IF

          'word fits but there must also be blanks on the ends
          IF flag% = false THEN
            IF start% = 1 THEN
              IF grid%(row%, start% + wdlen%) <> 0 THEN flag% = true
            ELSEIF start% + wdlen% - 1 = maxgrid% THEN
              IF grid%(row%, start% - 1) <> 0 THEN flag% = true
            ELSEIF grid%(row%, start% - 1) <> 0 OR grid%(row%, start% + wdlen%) <> 0 THEN
              flag% = true
            END IF
          END IF

          'word fits but there might be llegal combos above and below
          IF flag% = false THEN
            FOR j% = 1 TO wdlen%
              IF j% <> chpos% THEN
                tcol% = start% + j% - 1
                IF row% > 1 THEN
                  IF grid%(row% - 1, tcol%) <> 0 THEN
                    flag% = true: EXIT FOR
                  END IF
                END IF
                IF row% < maxgrid% THEN
                  IF grid%(row% + 1, tcol%) <> 0 THEN
                    flag% = true: EXIT FOR
                  END IF
                END IF
              END IF
            NEXT j%
          END IF

          'word fits here so save info
          IF flag% = false THEN
            srow% = row%
            scol% = start%
            GOSUB AddMatch
          END IF

          'keep searching, the same word might fit in another position
          spos% = chpos% + 1
          chpos% = INSTR(spos%, wd$, ch$)
        LOOP
      END IF
    NEXT i%

  END IF

  'got a match?
  IF matchindex% THEN
    'if there's only one match then we're done
    IF matchindex% = 1 THEN
      best% = 1

    'else find highest number of letter matches
    'at least one word MUST be max since a match was found
    ELSE
      max% = 0
      FOR i% = 1 TO matchindex%
        IF matchinfo%(i%, 3) > max% THEN max% = matchinfo%(i%, 3)
      NEXT i%

      'now make list of best matches in hitlist%()
      hit% = 0
      FOR i% = 1 TO matchindex%
        IF matchinfo%(i%, 3) = max% THEN
          hit% = hit% + 1
          hitlist%(hit%) = i%
        END IF
      NEXT i%

      'if best hit is unique then we're done
      IF hit% = 1 THEN
        best% = hitlist%(hit%)

      'else pick best word from list
      'there's a choice of methods based on word length
      'high score words are first in the list
      ELSE
        best% = nada
        SELECT CASE findtype%

          'pick shortest word in the list, randomize equals
          CASE findshort
            min% = 666
            FOR i% = 1 TO hit%
              IF wordlength%(matchinfo%(hitlist%(i%), 0)) < min% THEN
                min% = wordlength%(matchinfo%(hitlist%(i%), 0))
                best% = hitlist%(i%)
              ELSEIF wordlength%(matchinfo%(hitlist%(i%), 0)) = min% THEN
                IF RND < .5 THEN
                  min% = wordlength%(matchinfo%(hitlist%(i%), 0))
                  best% = hitlist%(i%)
                END IF
              END IF
            NEXT i%

          'pick longest word in the list, randomize equals
          CASE findlong
            max% = 0
            FOR i% = 1 TO hit%
              IF wordlength%(matchinfo%(hitlist%(i%), 0)) > max% THEN
                max% = wordlength%(matchinfo%(hitlist%(i%), 0))
                best% = hitlist%(i%)
              ELSEIF wordlength%(matchinfo%(hitlist%(i%), 0)) = max% THEN
                IF RND < .5 THEN
                  max% = wordlength%(matchinfo%(hitlist%(i%), 0))
                  best% = hitlist%(i%)
                END IF
              END IF
            NEXT i%
        
          'pick medium word in the list
          CASE findmiddle
            'prefer 6 (?) letter words
            min% = 666
            FOR i% = 1 TO hit%
              IF ABS(wordlength%(matchinfo%(hitlist%(i%), 0)) - midlength%) < min% THEN
                min% = wordlength%(matchinfo%(hitlist%(i%), 0))
                best% = hitlist%(i%)
              END IF
            NEXT i%

          'else just take first one (which should be top score)
          CASE ELSE
            best% = 1
            'best% = hitlist%(1)
          
        END SELECT
      END IF
    END IF

    'send back best fit
    index% = matchinfo%(best%, 0)
    srow% = matchinfo%(best%, 1)
    scol% = matchinfo%(best%, 2)
    flag% = true

  'else no match was found
  ELSE
    flag% = false
  END IF

  FindWord2% = flag%
EXIT FUNCTION

'found a word that fits, save info for later
AddMatch:
  matchindex% = matchindex% + 1
  matchinfo%(matchindex%, 0) = wdindex%
  matchinfo%(matchindex%, 1) = srow%
  matchinfo%(matchindex%, 2) = scol%
  matchinfo%(matchindex%, 3) = match%
RETURN

END FUNCTION

'Wait for a keypress
'
FUNCTION GetKey%
  DO: n$ = INKEY$: LOOP UNTIL LEN(n$)
  IF LEN(n$) = 1 THEN GetKey% = ASC(UCASE$(n$)) ELSE GetKey% = -ASC(RIGHT$(n$, 1))
END FUNCTION

SUB InputGridSize
  SHARED maxgrid%, screenheight%

  oldgrid% = maxgrid%
  GOSUB igsShowGrid

  DO
    SELECT CASE UCASE$(INPUT$(1))
      CASE "Q", esc$: maxgrid% = oldgrid%: EXIT DO
      CASE "M", enter$: EXIT DO
      CASE "+"
        IF maxgrid% < maxgridsize THEN
          maxgrid% = maxgrid% + 1
          GOSUB igsShowGrid
        ELSE
          SoundBop
        END IF
      CASE "-"
        IF maxgrid% > mingridsize THEN
          maxgrid% = maxgrid% - 1
          GOSUB igsShowGrid
        ELSE
          SoundBop
        END IF
      CASE ELSE: SoundBeep
    END SELECT
  LOOP
EXIT SUB

igsShowGrid:
  SizeScreen screenheight%
  NewWordGrid
  ShowNewGrid
  BottomLine "New Grid size: <+/-> <Enter>=accept <Esc>=cancel"
RETURN

END SUB

SUB InputWordList (flag%)
  SHARED wordfile$, menu$
  SHARED botline%

  BottomLine "New word list: "
  COLOR white, blue
  LOCATE botline%, 17
  LINE INPUT ; "", newfile$
  newfile$ = LTRIM$(RTRIM$(UCASE$(newfile$)))
  flag% = false

  'see if file exists
  IF LEN(newfile$) THEN
    IF INSTR(newfile$, ".") = 0 THEN newfile$ = newfile$ + ".txt"
    IF LEN(DIR$(newfile$)) THEN
      wordfile$ = newfile$
      flag% = true
    ELSE
      BottomMsg "Can't open file!  (press any key)"
    END IF
  END IF

  BottomLine menu$
  COLOR white, black
  
END SUB

'Read grid data from a saved text file, but NOT word file!
'This is a kludge I needed but it will get weird if the loaded file
'uses a different word list from the installed list.  Beware!
'
SUB LoadGrid
  SHARED word$()
  SHARED grid%(), used%(), bestgrid%(), bestused%()
  SHARED menu$
  SHARED maxgrid%, maxword%, botline%, statline%

  BottomLine "Load grid: "
  COLOR white, blue
  LOCATE botline%, 13
  LINE INPUT ; "", newfile$
  COLOR white, black
  newfile$ = LTRIM$(RTRIM$(UCASE$(newfile$)))
  flag% = false

  'see if file exists
  IF LEN(newfile$) THEN
    IF INSTR(newfile$, ".") = 0 THEN newfile$ = newfile$ + ".txt"
    IF LEN(DIR$(newfile$)) THEN
      gridfile$ = newfile$
      flag% = true
    ELSE
      BottomMsg "Can't open file!  (press any key)"
    END IF
  END IF

  'got filename, now try to find the grid
  IF flag% THEN
    filenum% = FREEFILE
    OPEN gridfile$ FOR INPUT AS #filenum%
    flag% = false
    DO UNTIL EOF(filenum%)
      LINE INPUT #filenum%, in$
      IF LCASE$(in$) = "<begin grid>" THEN
        flag% = true
        EXIT DO
      END IF
    LOOP

    IF flag% = false THEN
      BottomMsg "Grid data not found in file: " + gridfile$ + " (press any key)"
    ELSE
      'ClearGrid
      row% = 0
      DO
        LINE INPUT #filenum%, in$

        'are we done?
        IF LCASE$(in$) = "<end grid>" THEN
          EXIT DO
        ELSE
          row% = row% + 1
        END IF

        'reset gridsize if it's the first line
        IF row% = 1 THEN
          maxgrid% = LEN(in$) \ 2
          NewGridSize
        END IF
          
        'read the data, it's either a lowercase letter or "-" if null
        FOR col% = 1 TO maxgrid%
          ch$ = MID$(in$, col% + col% - 1, 1)
          IF ch$ = "-" THEN
            grid%(row%, col%) = 0
          ELSE
            grid%(row%, col%) = ASC(ch$)
          END IF
        NEXT col%
      LOOP

      'put what we got in bestgrid%()
      FOR row% = 1 TO maxgrid%
        FOR col% = 1 TO maxgrid%
          bestgrid%(row%, col%) = grid%(row%, col%)
        NEXT col%
      NEXT row%
    
      'keep reading to get list of used names
      badword% = false
      wordcnt% = 0
      REDIM used%(maxword%)
      DO UNTIL EOF(filenum%)
        LINE INPUT #filenum%, in$
        IF in$ = "These words are used:" THEN
          LINE INPUT #filenum%, in$               'null line
          DO UNTIL EOF(filenum%)
            LINE INPUT #filenum%, in$
            IF LEFT$(in$, 1) <> "(" THEN
              flag% = true                        'set true if word not in list
              FOR i% = 1 TO maxword%
                IF in$ = word$(i%) THEN
                  flag% = false
                  used%(i%) = true
                  wordcnt% = wordcnt% + 1
                END IF
              NEXT i%
              IF flag% THEN badword% = badword% + 1
            END IF
          LOOP

          'save this word list
          FOR i% = 1 TO maxword%
            bestused%(i%) = used%(i%)
          NEXT i%

          'bad wordlist warning??
          IF badword% THEN
            BottomMsg LTRIM$(STR$(badword%)) + " words are NOT in current word list!"
          END IF

        END IF
      LOOP
      ScoreGrid words%, letters%, connections%
      runtime! = 0
      try& = 0
      ShowStats "grid", statline%, try&, words%, letters%, connections%, runtime!
      SaveBestGrid try&, words%, letters%, connections%, runtime!
      ShowBestGrid

    END IF

    CLOSE #filenum%

  END IF
  
  BottomLine menu$
  COLOR white, black
  
END SUB

'Actually make an xword.
'This assumes that one or more words are placed (somewhere) on the grid.
'Returns after <Esc> or when can't do anything else.
'
SUB MakeXword
  SHARED grid%()
  SHARED maxgrid%
  SHARED maketype%

  'random start direction
  direction% = INT(RND * 2)

  DO
    gotit% = false
    FOR row% = 1 TO maxgrid%
      FOR col% = 1 TO maxgrid%
        IF grid%(row%, col%) THEN

          'now what?
          gotit% = false
          SELECT CASE maketype%
            CASE makefind
              direction% = FindDirection%(row%, col%)
              IF direction% <> nada THEN
                gotit% = FindWord2%(row%, col%, direction%, index%, srow%, scol%)
              END IF
            CASE makealternate
              OtherDirection direction%
              gotit% = FindWord2%(row%, col%, direction%, index%, srow%, scol%)
              IF NOT gotit% THEN
                OtherDirection direction%
                gotit% = FindWord2%(row%, col%, direction%, index%, srow%, scol%)
              END IF
            CASE makerandom
              direction% = INT(RND * 2)
              gotit% = FindWord2%(row%, col%, direction%, index%, srow%, scol%)
              IF NOT gotit% THEN
                OtherDirection direction%
                gotit% = FindWord2%(row%, col%, direction%, index%, srow%, scol%)
              END IF
          END SELECT

          IF gotit% THEN
            PlaceWord srow%, scol%, direction%, index%
            EXIT FOR
          END IF
        END IF

      NEXT col%
      IF gotit% THEN EXIT FOR

    NEXT row%
    IF NOT gotit% THEN EXIT DO
    
    'rescore words that are left?  Resort them?
    'ScoreWords
    'QSortScore

  LOOP

END SUB

SUB NewGridSize
  SHARED grid%(), bestgrid%(), mingrid%()
  SHARED maxgrid%, bestwords%, minwords%, screenheight%

  'these depend on maxgrid%
  REDIM grid%(1 TO maxgrid%, 1 TO maxgrid%)     'the grid letter by letter
  REDIM bestgrid%(1 TO maxgrid%, 1 TO maxgrid%) 'the best grid (so far) letter by letter
  REDIM mingrid%(1 TO maxgrid%, 1 TO maxgrid%)  'the worst grid (so far) letter by letter
  bestwords% = 0
  minwords% = 666

  'set up screen
  SizeScreen screenheight%
  NewWordGrid

END SUB

SUB NewSettings
  SHARED norandom%

  IF NOT norandom% THEN RANDOMIZE TIMER

END SUB

'Prepare screen display for later display by ShowNewGrid()
'It does show a few things that won't change
'
SUB NewWordGrid
  SHARED word$(), wordrs$()
  SHARED wordlength%(), wordscore%()
  SHARED wordrc%()
  SHARED maxword%, maxlength%, maxgrid%
  SHARED statline%, bestline%, botline%
  SHARED wordstart%, wordwide%
  SHARED slidetop%, slidebot%, slidehigh%, lastslide%, slidecolor%
  SHARED slide$, slidemark$, uparrow$, downarrow$
  SHARED wordtoprow%, wordbotrow%
  SHARED wordtop%, wordbot%, wordnum%, wordlast%, wordscroll%

  'size of word list columns is figured in SizeScreen()
  'as wordstart%, wordwide%

  'info box
  COLOR black, brown
  LOCATE 1, 1: PRINT CHR$(186); "Treebeard's X-Worder"; TAB(wordstart% - 3); CHR$(186);
  LOCATE 2, 1: PRINT CHR$(186); maxword%; "words,"; maxgrid%; "x"; maxgrid%; TAB(wordstart% - 3); CHR$(186);
  
  'status lines
  ShowStats "grid", statline%, 0&, 0, 0, 0, 0!
  ShowStats "best", bestline%, 0&, 0, 0, 0, 0!

  'Figure best way to show new word list from word$()
  'Do we need to scroll for long word lists?
  'Try to figure everything now for fast update later
  '(This is pretty ugly code!)

  'shared
  wordtoprow% = 1                       'top row of screen to use
  wordbotrow% = botline% - 2            'bottom row of screen to use
  wordtop% = wordtoprow%                        'current top row to show
  wordnum% = wordbotrow% - wordtoprow% + 1      'how many rows fit on screen
  wordbot% = wordtop% + wordnum% - 1            'lowest row on screen
  
  'just local
  thisrow% = wordtoprow%
  wordwide% = maxlength% + 7
  thiscol% = wordstart% - 1
  wordcols% = (80 - wordstart% - 2) \ wordwide%
  colwide% = (80 - wordstart% - 2) \ wordcols%
  wordpercol% = maxword% \ wordcols% + 1
  lastrow% = wordtoprow% + wordpercol% - 1

  'also shared
  wordscroll% = (wordpercol% > wordbotrow%)    'true if need to scroll
  wordlast% = wordpercol% - wordnum% + 2       'last valid wordtop%
  IF wordlast% < 1 THEN wordlast% = 1
  
  FOR i% = 1 TO maxword%
    'string for this word and (score)
    n$ = SPACE$(wordwide%)
    m$ = " (" + LTRIM$(STR$(wordscore%(i%))) + ")"
    MID$(n$, wordwide% - LEN(m$)) = m$
    MID$(n$, 1) = " " + word$(i%)

    'remember location of each word in its column for later display
    wordrc%(i%, 0) = thisrow%
    wordrc%(i%, 1) = thiscol%
    wordrs$(i%) = n$

    'get ready for next word, bump to next row if necessary
    thisrow% = thisrow% + 1
    IF thisrow% > lastrow% THEN
      thisrow% = wordtoprow%
      thiscol% = thiscol% + colwide%
    END IF
  NEXT i%

  'scroll bar for word list
  COLOR white, blue
  LOCATE slidetop% - 1, 80: PRINT uparrow$;
  LOCATE slidebot% + 1, 80: PRINT downarrow$;
  COLOR white, blue
  FOR i% = slidetop% TO slidebot%
    LOCATE i%, 80: PRINT slide$;
  NEXT i%

  lastslide% = slidetop%
  IF wordscroll% THEN slidecolor% = white ELSE slidecolor% = gray
  COLOR slidecolor%, blue
  LOCATE lastslide%, 80: PRINT slidemark$;

END SUB

SUB NewWordList
  SHARED word$()
  SHARED wordasc%(), wordlength%(), wordscore%()
  SHARED wordrc%(), wordrs$(), used%(), bestused%(), minused%()
  SHARED sortscore%()
  SHARED wordfile$
  SHARED maxword%, maxlength%

  'get the word list
  maxword% = 0                          'number of words (1..n)
  maxlength% = 0                        'longest word
  ReadWordList wordfile$

  'these depend on word list
  REDIM wordasc%(1 TO maxword%, 1 TO maxlength%)'each word as ascii array
  REDIM wordlength%(1 TO maxword%)              'word index by length
  REDIM wordscore%(1 TO maxword%)               'score for letters in word list
  REDIM wordrc%(1 TO maxword%, 1)               'row, col for each name display
  REDIM wordrs$(1 TO maxword%)                  'name (score) for each name
  REDIM used%(1 TO maxword%)                    'flag true if name already used
  REDIM bestused%(1 TO maxword%)                'flag true if name used in bestgrid%()
  REDIM minused%(1 TO maxword%)                 'flag true if name used in mingrid%()
  REDIM sortscore%(1 TO maxword%)               'sort word index by score

  'process the word list
  QSort word$(), 1, maxword%
  CountLetters
  ScoreWords
  QSortScore

END SUB

SUB OtherDirection (dr%)
  IF dr% = across THEN dr% = down ELSE dr% = across
END SUB

'Pick a first word for the grid
'
SUB PickWord (row%, col%, direction%, index%)
  SHARED sortscore%(), wordlength%()
  SHARED rndfac!
  SHARED maxword%, maxgrid%
    
  'mostly start in corners, or nearby
  IF RND < rndfac! THEN
    index% = sortscore%(maxword%)
    SELECT CASE INT(RND * 4)
      'top left corner
      CASE 0
        row% = 1
        col% = 1
        IF RND < .5 THEN direction% = across ELSE direction% = down

      'top right corner
      CASE 1
        IF RND < .5 THEN
          direction% = across
          row% = 1
          col% = maxgrid% - wordlength%(index%) + 1
        ELSE
          direction% = down
          row% = 1
          col% = maxgrid%
        END IF

      'bottom right corner
      CASE 2
        IF RND < .5 THEN
          direction% = across
          row% = maxgrid%
          col% = maxgrid% - wordlength%(index%) + 1
        ELSE
          direction% = down
          row% = maxgrid% - wordlength%(index%) + 1
          col% = maxgrid%
        END IF

      'bottom left corner
      CASE 3
        IF RND < .5 THEN
          direction% = across
          row% = maxgrid%
          col% = 1
        ELSE
          direction% = down
          row% = maxgrid% - wordlength%(index%) + 1
          col% = maxgrid%
        END IF
    END SELECT

  'or try something different and start in random place
  ELSE
    index% = 1 + INT(RND * maxword%)
    IF RND < .5 THEN direction% = across ELSE direction% = down
    IF direction% = across THEN
      row% = 1 + INT(RND * maxgrid%)
      col% = 1 + INT(RND * (maxgrid% - wordlength%(index%) - 1))
    ELSE
      row% = 1 + INT(RND * (maxgrid% - wordlength%(index%) - 1))
      col% = 1 + INT(RND * maxgrid%)
    END IF
  END IF

END SUB

'Place word on puzzle and show it on display
'This assumes that a word is legal in given location.
'
SUB PlaceWord (row%, col%, direction%, index%)
  SHARED word$()
  SHARED wordlength%(), wordasc%()
  SHARED grid%(), used%()
  SHARED displayflag%

  IF displayflag% THEN
    COLOR black, cyan
    n$ = word$(index%)
  END IF

  'across
  IF direction% = across THEN
    IF displayflag% THEN
      LOCATE startrow + row%, startcol + col%
      PRINT n$;
    END IF
    pcol% = col% - 1
    FOR i% = 1 TO wordlength%(index%)
      grid%(row%, pcol% + i%) = wordasc%(index%, i%)
    NEXT i%

  'down
  ELSEIF direction% = down THEN
    prow% = row% - 1
    nrow% = startrow + row% - 1
    ncol% = startcol + col%
    FOR i% = 1 TO wordlength%(index%)
      grid%(prow% + i%, col%) = wordasc%(index%, i%)
      IF displayflag% THEN
        LOCATE nrow% + i%, ncol%
        PRINT MID$(n$, i%, 1);
      END IF
    NEXT i%
  END IF

  'highlight word on list and restore colors
  IF displayflag% THEN
    ShowWord index%
    COLOR white, black
  END IF

  'mark word as used
  used%(index%) = true

END SUB

SUB PrintGrid

END SUB

SUB QSort (array$(), start%, finish%)
  num% = finish% - start% + 1
  REDIM qstack%(num% \ 5 + 10)
  first% = start%
  last% = start% + num% - 1

  DO
    DO
      temp$ = array$((last% + first%) \ 2)
      i% = first%
      j% = last%

      DO
        WHILE array$(i%) < temp$
          i% = i% + 1
        WEND
        WHILE array$(j%) > temp$
          j% = j% - 1
        WEND
        IF i% > j% THEN EXIT DO
        IF i% < j% THEN SWAP array$(i%), array$(j%)
        i% = i% + 1
        j% = j% - 1
      LOOP WHILE i% <= j%

      IF i% < last% THEN
        qstack%(ptr%) = i%
        qstack%(ptr% + 1) = last%
        ptr% = ptr% + 2
      END IF

      last% = j%
    LOOP WHILE first% < last%

    IF ptr% = 0 THEN EXIT DO
    ptr% = ptr% - 2
    first% = qstack%(ptr%)
    last% = qstack%(ptr% + 1)
  LOOP

END SUB

'Make a sorted index to word%() by letter score, from low to high
'High scores are at the END of sortscore%()
'
SUB QSortScore
  SHARED wordscore%(), sortscore%()
  SHARED maxword%

  start% = 1
  last% = maxword%
  FOR i% = start% TO last%
    sortscore%(i%) = i%
  NEXT i%

  num% = last% - start% + 1
  REDIM qstack%(num% \ 5 + 10)
  first% = start%
  last% = start% + num% - 1

  DO
    DO
      temp% = wordscore%(sortscore%((last% + first%) \ 2))
      i% = first%
      j% = last%

      DO
        WHILE wordscore%(sortscore%(i%)) < temp%
          i% = i% + 1
        WEND
        WHILE wordscore%(sortscore%(j%)) > temp%
          j% = j% - 1
        WEND
        IF i% > j% THEN EXIT DO
        IF i% < j% THEN
          SWAP sortscore%(i%), sortscore%(j%)
        END IF
        i% = i% + 1
        j% = j% - 1
      LOOP WHILE i% <= j%

      IF i% < last% THEN
        qstack%(ptr%) = i%
        qstack%(ptr% + 1) = last%
        ptr% = ptr% + 2
      END IF

      last% = j%
    LOOP WHILE first% < last%

    IF ptr% = 0 THEN EXIT DO
    ptr% = ptr% - 2
    first% = qstack%(ptr%)
    last% = qstack%(ptr% + 1)
  LOOP

END SUB

'read wordlist from disk file
'letters a-z ONLY, no spaces or other marks allowed
'
SUB ReadWordList (filename$)
  SHARED word$()
  SHARED maxword%, maxlength%, wordfilesize%

  wordfilenum% = FREEFILE
  thisword% = 0
  maxword% = 0
  maxlength% = 0

  'first count words in file, this is for QB without REDIM PRESERVE
  OPEN filename$ FOR INPUT AS #wordfilenum%
  wordfilesize% = LOF(wordfilenum%)
  DO UNTIL EOF(1)
    INPUT #wordfilenum%, n$
    IF LEN(LCASE$(LTRIM$(RTRIM$(n$)))) THEN maxword% = maxword% + 1
  LOOP
  CLOSE #wordfilenum%

  'this holds the wordlist from 1 to maxword%
  REDIM word$(1 TO maxword%)

  'now do it again and read all the words
  OPEN filename$ FOR INPUT AS #wordfilenum%
  DO UNTIL EOF(wordfilenum%)
    'lower case
    INPUT #wordfilenum%, n$
    t$ = LCASE$(LTRIM$(RTRIM$(n$)))

    'trim all letters but a-z
    n$ = ""
    FOR i% = 1 TO LEN(t$)
      ch% = ASC(MID$(t$, i%, 1))
      IF ch% >= asca AND ch% <= ascz THEN
        n$ = n$ + CHR$(ch%)
      END IF
    NEXT i%

    'add to list
    nlen% = LEN(n$)
    IF nlen% THEN
      IF nlen% > maxlength% THEN maxlength% = nlen%
      thisword% = thisword% + 1
      word$(thisword%) = n$
    END IF
  LOOP

  CLOSE #wordfilenum%

END SUB

'Save grid if best so far, using number of words as main criterion.
'
SUB SaveBestGrid (try&, words%, letters%, connections%, runtime!)
  SHARED besttime!, besttry&, bestwords%, bestletters%, bestconnections%
  SHARED bestgrid%(), grid%()
  SHARED bestused%(), used%()
  SHARED maxword%, maxgrid%, displayflag%
  SHARED statline%, bestline%

  IF words% > bestwords% THEN
    GOSUB sbgSaveBest
  ELSEIF words% = bestwords% THEN
    IF letters% > bestletters% THEN
      GOSUB sbgSaveBest
    ELSEIF letters% = bestletters% THEN
      IF connections% > bestconnections% THEN
        GOSUB sbgSaveBest
      END IF
    END IF
  END IF

EXIT SUB

sbgSaveBest:
  besttime! = runtime!
  besttry& = try&
  bestwords% = words%
  bestletters% = letters%
  bestconnections% = connections%
  
  'save grid
  FOR i% = 1 TO maxgrid%
    FOR j% = 1 TO maxgrid%
      bestgrid%(i%, j%) = grid%(i%, j%)
    NEXT j%
  NEXT i%

  'save word list
  FOR i% = 1 TO maxword%
    bestused%(i%) = used%(i%)
  NEXT i%

  'update displays
  ShowStats "best", bestline%, besttry&, bestwords%, bestletters%, bestconnections%, besttime!
  IF NOT displayflag% THEN ShowBestGrid
RETURN

END SUB

SUB SaveGrid (deviceflag%)
  SHARED savefile$, wordfile$, menu$
  SHARED word$()
  SHARED wordavg!, wordstd!
  SHARED bestgrid%(), bestused%()
  SHARED maxgrid%, maxword%, maxlength%, wordfilesize%
  SHARED bestwords%, bestletters%, bestconnections%
  SHARED try&, besttry&, besttime!

  'print to LPT1:
  IF deviceflag% THEN
    file$ = "LPT1:"
    BottomLine "Printing..."

  'save to file
  ELSE
    'save as form BESTXXX.TXT, don't overwrite old files
    i% = 0
    DO
      i% = i% + 1
      file$ = savefile$ + RIGHT$("000" + LTRIM$(STR$(i%)), 3) + ".txt"
    LOOP WHILE LEN(DIR$(file$))
    BottomLine "Saving..."
  END IF

  'the rest of this is device independent for file and printer
  filenum% = FREEFILE
  OPEN file$ FOR OUTPUT AS #filenum%
  
  'stats
  PRINT #filenum%, "Treebeard's X-Worder, " + ver
  PRINT #filenum%, "date, time: " + DATE$ + ", "; TIME$
  PRINT #filenum%, "grid size:  " + LTRIM$(STR$(maxgrid%)) + " x " + LTRIM$(STR$(maxgrid%))
  PRINT #filenum%, "word file:  <" + wordfile$ + ">, " + LTRIM$(STR$(maxword%)) + " words, " + LTRIM$(STR$(wordfilesize%)) + " bytes"
  PRINT #filenum%, "mean, std:  " + LTRIM$(STR$(wordavg!)) + " , " + LTRIM$(STR$(wordstd!))
  PRINT #filenum%, "best grid:  " + LTRIM$(STR$(besttry&)) + " of "; LTRIM$(STR$(try&))
  PRINT #filenum%, "best words: " + LTRIM$(STR$(bestwords%)) + " of "; LTRIM$(STR$(maxword%)) + "    conns: " + LTRIM$(STR$(bestconnections%)) + "    lettr: " + LTRIM$(STR$(bestletters%)) + "    cover: " + LTRIM$(STR$(INT(100! * bestletters% / ( _
maxgrid% * maxgrid%)))) + "%"
  PRINT #filenum%, "run time:   " + ClockTimeStr$(besttime!)
  PRINT #filenum%, "time/grid:  " + LTRIM$(STR$(ClockStopTime! / CSNG(try&))) + " sec"
  PRINT #filenum%,
  PRINT #filenum%, "<begin grid>"
  
  'the grid
  blankline$ = ""
  FOR i% = 1 TO maxgrid%
    blankline$ = blankline$ + "- "
  NEXT i%
  
  FOR i% = 1 TO maxgrid%
    n$ = blankline$
    FOR j% = 1 TO maxgrid%
      IF bestgrid%(i%, j%) THEN
        MID$(n$, j% + j% - 1, 1) = CHR$(bestgrid%(i%, j%))
      END IF
    NEXT j%
    PRINT #filenum%, n$
  NEXT i%
  PRINT #filenum%, "<end grid>"

  'Unused words
  PRINT #filenum%,
  PRINT #filenum%, "These words are still unused:"
  PRINT #filenum%, "-----------------------------"
  count% = 0
  FOR i% = 1 TO maxword%
    IF NOT bestused%(i%) THEN
      PRINT #filenum%, word$(i%)
      count% = count% + 1
    END IF
  NEXT i%
  PRINT #filenum%, "(" + LTRIM$(STR$(count%)) + " words still unused)"

  'Used words
  PRINT #filenum%,
  PRINT #filenum%, "These words are used:"
  PRINT #filenum%, "---------------------"
  count% = 0
  FOR i% = 1 TO maxword%
    IF bestused%(i%) THEN
      PRINT #filenum%, word$(i%)
      count% = count% + 1
    END IF
  NEXT i%
  PRINT #filenum%, "(" + LTRIM$(STR$(count%)) + " words used)"

  'send form feed (Asc 12) only to printer
  IF deviceflag% THEN
    PRINT #filenum%, CHR$(12)
  END IF

  CLOSE #filenum%
  'show prompt for file saves only
  IF NOT deviceflag% THEN
    SoundBeep
    BottomMsg "Puzzle saved as: " + file$ + " (press any key)"
  END IF
  BottomLine menu$

END SUB

'Save best grid as two web pages with blank grid AND answers filled in.
'
SUB SaveHTML
  SHARED savefile$, menu$
  SHARED bestgrid%(), bestused%(), used%()
  SHARED besttime!, try&, besttry&
  SHARED bestwords%, bestletters%, bestconnections%
  SHARED maxword%, maxgrid%
  SHARED statline%, bestline%
  SHARED bgcolorflag%

  'new word directions
  CONST noword = 0
  CONST acrossword = 1
  CONST downword = 2
  CONST bothword = 3

  'hold word lists for printing
  DIM acrosslist$(1 TO maxword%)
  DIM downlist$(1 TO maxword%)

  'save Webpage as form WEBXXX.HTM, don't overwrite old files
  i% = 0
  DO
    i% = i% + 1
    fileid$ = "WEB" + RIGHT$("000" + LTRIM$(STR$(i%)), 3)
    file$ = fileid$ + ".HTM"
  LOOP WHILE LEN(DIR$(file$))
  BottomLine "Saving as HTML Web pages: " + file$ + "..."

  'make blank grid
  answerflag% = false
  GOSUB shtmlMakeFile

  'make answer grid
  answerflag% = true
  file$ = fileid$ + "a" + ".HTM"
  GOSUB shtmlMakeFile

  'restore screen
  SoundBeep
  BottomMsg "HTML Web page saved as: " + fileid$ + "a" + ".HTM and " + file$ + " (press any key)"
  BottomLine menu$
EXIT SUB

shtmlMakeFile:
  'silly to do this twice, but it's easiest
  acrossptr% = 0
  downptr% = 0
  wordnum% = 0

  filenum% = FREEFILE
  OPEN file$ FOR OUTPUT AS #filenum%
  
  PRINT #filenum%, "<HTML>"
  PRINT #filenum%, "<HEAD>"
  PRINT #filenum%, "<TITLE>" + file$ + "</TITLE>"
  PRINT #filenum%, "</HEAD>"
  PRINT #filenum%, "<BODY>"
  PRINT #filenum%, "<CENTER><H1>" + file$ + "</H1></CENTER>"
  PRINT #filenum%, "<P>"
  PRINT #filenum%, "<CENTER>"

  'START outer table
  PRINT #filenum%, "<TABLE ALIGN=" + q$ + "center" + q$ + " BGCOLOR=" + q$ + "red" + q$ + " BORDER=3 CELLSPACING=1 CELLPADDING=1 >"
  PRINT #filenum%, "<TR VALIGN=" + q$ + "middle" + q$ + ">"
  PRINT #filenum%, "<TD ALIGN=" + q$ + "center" + q$ + ">"

  'START inner table
  PRINT #filenum%, "<CENTER>"
  PRINT #filenum%, "<TABLE ALIGN=" + q$ + "center" + q$ + " BGCOLOR=" + q$ + "white" + q$ + " BORDER=1 BORDERCOLOR=" + q$ + "black" + q$ + " CELLSPACING=1 CELLPADDING=1>"

  'each row
  FOR row% = 1 TO maxgrid%
    PRINT #filenum%, "<TR VALIGN=" + q$ + "top" + q$ + ">"

    'each column
    FOR col% = 1 TO maxgrid%
      IF bestgrid%(row%, col%) THEN
        'new word number?

        'find letters in surrounding cells, add nulls on edge
        IF row% = 1 THEN tword% = 0 ELSE tword% = bestgrid%(row% - 1, col%)
        IF row% = maxgrid% THEN bword% = 0 ELSE bword% = bestgrid%(row% + 1, col%)
        IF col% = 1 THEN lword% = 0 ELSE lword% = bestgrid%(row%, col% - 1)
        IF col% = maxgrid% THEN rword% = 0 ELSE rword% = bestgrid%(row%, col% + 1)

        'assume no new word
        wordir% = noword

        'process new across word
        IF lword% = 0 AND rword% > 0 THEN
          wordir% = acrossword
          aword$ = ""
          FOR i% = col% TO maxgrid%
            IF bestgrid%(row%, i%) THEN
              aword$ = aword$ + CHR$(bestgrid%(row%, i%))
            ELSE
              EXIT FOR
            END IF
          NEXT i%
          wordnum% = wordnum% + 1

          'build HTML line for clue list
          acrossptr% = acrossptr% + 1
          acrosslist$(acrossptr%) = "<LI VALUE=" + LTRIM$(STR$(wordnum%)) + "> " + aword$
        END IF

        'process new down word, it may also be across with same number
        IF tword% = 0 AND bword% > 0 THEN
          dword$ = ""
          FOR i% = row% TO maxgrid%
            IF bestgrid%(i%, col%) THEN
              dword$ = dword$ + CHR$(bestgrid%(i%, col%))
            ELSE
              EXIT FOR
            END IF
          NEXT i%

          'don't bump wordnum if already across
          IF wordir% = acrossword THEN
            wordir% = bothword
          ELSE
            wordnum% = wordnum% + 1
            wordir% = downword
          END IF

          'build HTML line for clue list
          downptr% = downptr% + 1
          downlist$(downptr%) = "<LI VALUE=" + LTRIM$(STR$(wordnum%)) + "> " + dword$
        END IF

        'print letter for answer grid
        PRINT #filenum%, "<TD WIDTH=25 VALIGN=" + q$ + "top" + q$ + " ALIGN=" + q$ + "middle" + q$ + ">";
        IF wordir% THEN
          PRINT #filenum%, "<SUP><FONT SIZE=-1>" + LTRIM$(STR$(wordnum%)) + "</FONT></SUP>";
        END IF

        'print letters for answer or just a blank
        IF answerflag% THEN
          PRINT #filenum%, "<B>" + UCASE$(CHR$(bestgrid%(row%, col%))) + "</B></TD>"
        ELSE
          PRINT #filenum%, "&nbsp;</TD>"
        END IF

      'else print blank square
      ELSE
        IF bgcolorflag% THEN
          PRINT #filenum%, "<TD WIDTH=25 BGCOLOR=" + q$ + "black" + q$ + ">&nbsp;</TD>"
        ELSE
          PRINT #filenum%, "<TD WIDTH=25><IMG SRC=" + q$ + "black20.gif" + q$ + " HSPACE=0 VSPACE=0 BORDER=0>" + "</TD>"
        END IF
      END IF
    NEXT col%
    PRINT #filenum%, "</TR>"
  NEXT row%
  
  'END inner table
  PRINT #filenum%, "</TABLE>"
  PRINT #filenum%, "</CENTER>"

  'END outer table
  PRINT #filenum%, "</TD></TR>"
  PRINT #filenum%, "</TABLE>"
  PRINT #filenum%, "</CENTER>"
  
  'Now print the word lists in a two column table
  PRINT #filenum%, "<P>"
  PRINT #filenum%, "<CENTER>"
  PRINT #filenum%, "<TABLE WIDTH=" + q$ + "75%" + q$ + " BORDER=0 ALIGN=" + q$ + "center" + q$ + ">"
  PRINT #filenum%, "<TR VALIGN=" + q$ + "top" + q$ + ">"
  PRINT #filenum%, "<TD WIDTH=" + q$ + "50%" + q$ + " VALIGN=" + q$ + "top" + q$ + ">"
  PRINT #filenum%, "<FONT FACE=" + q$ + "ariel,helvetica" + q$ + ">"
  PRINT #filenum%, "<FONT SIZE=-1><CENTER><B>Across</B></CENTER><P>"
  PRINT #filenum%, "<OL TYPE=1>"
  FOR i% = 1 TO acrossptr%
   PRINT #filenum%, acrosslist$(i%)
  NEXT i%
  PRINT #filenum%, "</OL></FONT>"
  PRINT #filenum%, "</TD>"

  PRINT #filenum%, "<TD WIDTH=" + q$ + "50%" + q$ + " VALIGN=" + q$ + "top" + q$ + ">"
  PRINT #filenum%, "<FONT FACE=" + q$ + "ariel,helvetica" + q$ + ">"
  PRINT #filenum%, "<FONT SIZE=-1><CENTER><B>Down</B></CENTER><P>"
  PRINT #filenum%, "<OL TYPE=1>"
  FOR i% = 1 TO downptr%
   PRINT #filenum%, downlist$(i%)
  NEXT i%
  PRINT #filenum%, "</OL></FONT>"
  PRINT #filenum%, "</TD>"

  PRINT #filenum%, "</TR>"
  PRINT #filenum%, "</TABLE>"
  PRINT #filenum%, "</CENTER>"
  
  'Finally print some info
  PRINT #filenum%, "<P><HR WIDTH=" + q$ + "50%" + q$ + "><P>"
  PRINT #filenum%, "Puzzle generated by Treebeard's XWORD.BAS program."
  PRINT #filenum%, "<BR>"
  PRINT #filenum%, DATE$, TIME$
  PRINT #filenum%, "<P>"

  'all done
  PRINT #filenum%, "</BODY>"
  PRINT #filenum%, "</HTML>"
  CLOSE #filenum%
RETURN

END SUB

SUB SaveMinGrid (try&, words%, letters%, connections%, runtime!)
  SHARED mintime!, mintry&, minwords%, minletters%, minconnections%
  SHARED mingrid%(), grid%()
  SHARED minused%(), used%()
  SHARED maxword%, maxgrid%, displayflag%
  SHARED statline%, bestline%

  'simplify, only look for fewer words
  IF words% < minwords% THEN
    mintime! = runtime!
    mintry& = try&
    minwords% = words%
    minletters% = letters%
    minconnections% = connections%

    'save grid
    FOR i% = 1 TO maxgrid%
      FOR j% = 1 TO maxgrid%
        mingrid%(i%, j%) = grid%(i%, j%)
      NEXT j%
    NEXT i%

    'save word list
    FOR i% = 1 TO maxword%
      minused%(i%) = used%(i%)
    NEXT i%

  END IF

  'DON't update displays

END SUB

SUB ScoreGrid (words%, letters%, connections%)
  SHARED grid%(), used%(), wordlength%()
  SHARED maxword%, maxgrid%
  SHARED totalwords&

  words% = 0            'how many words used
  letters% = 0          'how many letters
  connections% = 0      'how many connections
  
  words% = 0
  FOR i% = 1 TO maxword%
    IF used%(i%) THEN
      words% = words% + 1
      letters% = letters% + wordlength%(i%)
    END IF
  NEXT i%
  totalwords& = totalwords& + words%

  letters% = 0
  FOR row% = 1 TO maxgrid%
    FOR col% = 1 TO maxgrid%
      IF grid%(row%, col%) THEN letters% = letters% + 1
    NEXT col%
  NEXT row%

  'Counting connections is awkward
  '        tside%
  '  lside%  X   rside%
  '        bside%
  'To be a connection, there must be something (left OR right) AND (top or bottom)

  FOR row% = 1 TO maxgrid%
    FOR col% = 1 TO maxgrid%
      'don't bother unless something's here
      IF grid%(row%, col%) THEN
        SELECT CASE row%
          'top row
          CASE 1
            SELECT CASE col%
              'left column
              CASE 1
                tside% = false
                bside% = grid%(row% + 1, col%)
                lside% = false
                rside% = grid%(row%, col% + 1)
              'right column
              CASE maxgrid%
                tside% = false
                bside% = grid%(row% + 1, col%)
                lside% = grid%(row%, col% - 1)
                rside% = false
              'other columns
              CASE ELSE
                tside% = false
                bside% = grid%(row% + 1, col%)
                lside% = grid%(row%, col% - 1)
                rside% = grid%(row%, col% + 1)
            END SELECT

          'bottom row
          CASE maxgrid%
            SELECT CASE col%
              CASE 1
                tside% = grid%(row% - 1, col%)
                bside% = false
                lside% = false
                rside% = grid%(row%, col% + 1)
              CASE maxgrid%
                tside% = grid%(row% - 1, col%)
                bside% = false
                lside% = grid%(row%, col% - 1)
                rside% = false
              CASE ELSE
                tside% = grid%(row% - 1, col%)
                bside% = false
                lside% = grid%(row%, col% - 1)
                rside% = grid%(row%, col% + 1)
            END SELECT

          'middle rows
          CASE ELSE
            SELECT CASE col%
              CASE 1
                tside% = grid%(row% - 1, col%)
                bside% = grid%(row% + 1, col%)
                lside% = false
                rside% = grid%(row%, col% + 1)
              CASE maxgrid%
                tside% = grid%(row% - 1, col%)
                bside% = grid%(row% + 1, col%)
                lside% = grid%(row%, col% - 1)
                rside% = false
              CASE ELSE
                tside% = grid%(row% - 1, col%)
                bside% = grid%(row% + 1, col%)
                lside% = grid%(row%, col% - 1)
                rside% = grid%(row%, col% + 1)
            END SELECT
        END SELECT
        IF (lside% OR rside%) AND (tside% OR bside%) THEN connections% = connections% + 1
      END IF
    NEXT col%
  NEXT row%

END SUB

'score each word by letter frequency in wordscore%()
'but don't count letters in that word
'normalize score to length of word.
'
SUB ScoreWords
  SHARED word$()
  SHARED wordlength%(), letter%(), wordscore%(), used%()
  SHARED maxword%

  FOR i% = 1 TO maxword%
    IF NOT used%(i%) THEN
      score% = 0

      FOR j% = 1 TO wordlength%(i%)
        score% = score% + letter%(ASC(MID$(word$(i%), j%, 1)))
      NEXT j%

      'normalize score to length of word.
      wordscore%(i%) = score% \ wordlength%(i%) - 1
    END IF
  NEXT i%

END SUB

SUB ShowBestGrid
  SHARED bestgrid%(), bestused%(), used%()
  SHARED besttime!, try&, besttry&
  SHARED bestwords%, bestletters%, bestconnections%
  SHARED maxword%, maxgrid%
  SHARED statline%, bestline%
  
  ShowNewGrid
  ShowStats "best", statline%, try&, bestwords%, bestletters%, bestconnections%, besttime!
  COLOR black, cyan

  'the grid
  FOR i% = 1 TO maxgrid%
    FOR j% = 1 TO maxgrid%
      IF bestgrid%(i%, j%) THEN
        LOCATE startrow% + i%, startcol% + j%
        PRINT CHR$(bestgrid%(i%, j%));
      END IF
    NEXT j%
  NEXT i%

  'highlight used words.  ShowNewGrid() already showed all words.
  FOR i% = 1 TO maxword%
    IF bestused%(i%) THEN ShowWord i%
  NEXT i%

  COLOR white, black

END SUB

SUB ShowInfo
  SHARED savefile$, wordfile$, menu$
  SHARED word$()
  SHARED wordavg!, wordstd!
  SHARED bestgrid%(), bestused%()
  SHARED mingrid%(), minused%()
  SHARED maxgrid%, maxword%, maxlength%, wordfilesize%
  SHARED bestwords%, bestletters%, bestconnections%
  SHARED try&, besttry&, besttime!
  SHARED mintime!, mintry&, minwords%, minletters%, minconnections%
  SHARED totalwords&

  ClearWindow

  PRINT " Treebeard's X-Worder, " + ver
  PRINT " date, time:  " + DATE$ + ", "; TIME$
  PRINT " grid size:   " + LTRIM$(STR$(maxgrid%)) + " x " + LTRIM$(STR$(maxgrid%))
  PRINT " word file:   <" + wordfile$ + ">, " + LTRIM$(STR$(maxword%)) + " words, " + LTRIM$(STR$(wordfilesize%)) + " bytes"
  PRINT " mean, std:   " + LTRIM$(STR$(wordavg!)) + " , " + LTRIM$(STR$(wordstd!))
  PRINT
  PRINT " best grid:   " + LTRIM$(STR$(besttry&)) + " of " + LTRIM$(STR$(try&))
  PRINT " best words:  " + LTRIM$(STR$(bestwords%)) + " of " + LTRIM$(STR$(maxword%)) + "    conns: " + LTRIM$(STR$(bestconnections%)) + "    lettr: " + LTRIM$(STR$(bestletters%)) + "    cover: " + LTRIM$(STR$(INT(100! * bestletters% / (maxgrid% *  _
maxgrid%)))) + "%"
  PRINT " best time:   " + ClockTimeStr$(besttime!)
  PRINT
  PRINT " min grid:    " + LTRIM$(STR$(mintry&)) + " of " + LTRIM$(STR$(try&))
  PRINT " min words:   " + LTRIM$(STR$(minwords%)) + " of " + LTRIM$(STR$(maxword%)) + "    conns: " + LTRIM$(STR$(minconnections%)) + "    lettr: " + LTRIM$(STR$(minletters%)) + "    cover: " + LTRIM$(STR$(INT(100! * minletters% / (maxgrid% *  _
maxgrid%)))) + "%"
  PRINT " min time:    " + ClockTimeStr$(mintime!)
  PRINT
  PRINT " total grids: " + LTRIM$(STR$(try&))
  PRINT " word/grid:   " + LTRIM$(STR$(totalwords& \ try&))
  PRINT " total time:  " + ClockTimeStr$(ClockStopTime!)
  PRINT " time/grid:   " + LTRIM$(STR$(ClockStopTime! / CSNG(try&))) + " sec"
  
END SUB

SUB ShowMinGrid
  SHARED mingrid%(), minused%(), used%()
  SHARED mintime!, try&, mintry&
  SHARED minwords%, minletters%, minconnections%
  SHARED maxword%, maxgrid%
  SHARED statline%, bestline%

  ShowNewGrid
  ShowStats "min", statline%, try&, minwords%, minletters%, minconnections%, mintime!
  COLOR black, cyan

  'the grid
  FOR i% = 1 TO maxgrid%
    FOR j% = 1 TO maxgrid%
      IF mingrid%(i%, j%) THEN
        LOCATE startrow% + i%, startcol% + j%
        PRINT CHR$(mingrid%(i%, j%));
      END IF
    NEXT j%
  NEXT i%

  'highlight used words.  ShowNewGrid() already showed all words.
  FOR i% = 1 TO maxword%
    IF minused%(i%) THEN ShowWord i%
  NEXT i%

  COLOR white, black


END SUB

'Make a screen display with blank grid and word list
'
SUB ShowNewGrid
  SHARED maxword%, maxgrid%

  COLOR black, cyan
  LOCATE startrow + 1
  FOR i% = 1 TO maxgrid%
    LOCATE , startcol + 1
    PRINT STRING$(maxgrid%, dotchar)
  NEXT i%

  'show word list from word$()
  COLOR white, black
  FOR i% = 1 TO maxword%
    ShowWord i%
  NEXT i%

END SUB

SUB ShowStats (msg$, row%, try&, words%, letters%, connections%, runtime!)
  SHARED botline%
  SHARED maxgrid%
  
  IF row% = botline% THEN
    COLOR white, blue
  ELSE
    COLOR black, brown
  END IF
  
  LOCATE row%, 1: PRINT TAB(80); " ";
  LOCATE , 2: PRINT msg$; "-";
  LOCATE , 7: PRINT "("; : PRINT LTRIM$(STR$(try&)); ")";
  LOCATE , 16: PRINT " words:"; words%;
  LOCATE , 28: PRINT "conns:"; connections%;
  LOCATE , 39: PRINT "lettr:"; letters%;
  LOCATE , 51: PRINT "cover:"; STR$(INT(100! * letters% / (maxgrid% * maxgrid%))); "%";
  LOCATE , 63: PRINT "time: "; ClockTimeStr$(runtime!);
  COLOR white, black

END SUB

'Print a word from the list IF its visble on screen.
'It's up to the caller to worry about color for highlighting etc.
'
SUB ShowWord (index%)
  SHARED wordrs$()
  SHARED wordrc%()
  SHARED wordtop%, wordbot%, wordnum%, wordlast%, wordscroll%

  IF wordscroll% THEN
    thisrow% = wordrc%(index%, 0)
    IF thisrow% >= wordtop% AND thisrow% <= wordbot% THEN
      LOCATE wordrc%(index%, 0) - wordtop% + 1, wordrc%(index%, 1)
      PRINT wordrs$(index%);
    END IF
  ELSE
    LOCATE wordrc%(index%, 0), wordrc%(index%, 1)
    PRINT wordrs$(index%);
  END IF

END SUB

'Adjust top/bottom pointers for word list window.
'
SUB ShowWordAdjust (dif%)
  SHARED slide$, slidemark$, uparrow$, downarrow$
  SHARED wordtop%, wordbot%, wordnum%, wordlast%, wordscroll%
  SHARED slidetop%, slidebot%, slidehigh%, lastslide%, slidecolor%
  
  'make sure there's something to do.
  IF (dif% = 0) OR (NOT wordscroll%) THEN
    SoundBop

  'else change window settings, avoid overflow
  ELSE
    oldtop% = wordtop%
    wordtop% = wordtop% + dif%
    IF wordtop% < 1 THEN wordtop% = 1
    IF wordtop% > wordlast% THEN wordtop% = wordlast%
    wordbot% = wordtop% + wordnum% - 1

    IF wordtop% = oldtop% THEN
      SoundBop
    ELSE
      ClearWordWindow
      ShowBestGrid
      
      'adjust the slider
      COLOR slidecolor%, blue
      LOCATE lastslide%, 80: PRINT slide$;
      SELECT CASE wordtop%
        CASE 1: lastslide% = slidetop%
        CASE wordlast%: lastslide% = slidebot%
        CASE ELSE: lastslide% = slidetop% + slidehigh% * wordtop% / wordlast%
      END SELECT
      COLOR white, blue
      LOCATE lastslide%, 80: PRINT slidemark$;
      COLOR white, black
    END IF
  END IF

END SUB

'Screen height can be 25/43/50 only (for VGA)
'
SUB SizeScreen (screenheight%)
  SHARED maxword%, maxlength%, maxgrid%
  SHARED wordstart%, wordwide%
  SHARED statline%, bestline%, botline%
  SHARED slidetop%, slidebot%, slidehigh%, lastslide%
  
  'size of columns in display word list, used by NewWordGrid()
  wordstart% = maxgrid% + 5
  IF wordstart% < 25 THEN wordstart% = 25
  wordwide% = maxlength% + 7

  'screen size to contain grid
  IF maxgrid% > 39 THEN
    screenheight% = 50
  ELSEIF maxgrid% > 21 THEN
    screenheight% = 43
  ELSE
    screenheight% = 25
  END IF

  'need to increase screen size to show words?
  cols% = (80 - wordstart%) \ wordwide%
  DO
    numwords% = cols% * (screenheight% - 2)
    IF maxword% > numwords% THEN
      SELECT CASE screenheight%
        CASE 25: screenheight% = 43
        CASE 43: screenheight% = 50
        CASE 50: EXIT DO                'won't fit, so live with it
      END SELECT
    ELSE
      EXIT DO
    END IF
  LOOP

  'figure where bottom lines are
  bestline% = screenheight% - 1
  statline% = screenheight%
  botline% = screenheight%
  
  'set up slider
  slidetop% = 2
  slidebot% = botline% - 3
  slidehigh% = slidebot% - slidetop%
  
  'init the screen
  WIDTH 80, screenheight%
  CLS
  COLOR white, black
  
END SUB

SUB SoundBeep
  SOUND 660, 1
END SUB

SUB SoundBop
  SOUND 60, 1
END SUB

SUB XWordLoop (flag%)
  SHARED menu$, lmenu$, rmenu$
  SHARED displayflag%, singlestep%
  SHARED try&, besttry&, besttime!
  SHARED bestwords%, bestletters%, bestconnections%
  SHARED maxword%, maxgrid%, mingrid%
  SHARED statline%, bestline%

  'main loop
  ClockReset
  try& = 0
  newgrid% = false
  done% = false

  'do inner loop for every try
  DO
    'out with the old
    try& = try& + 1&
    ClearGrid
    IF displayflag% THEN ShowNewGrid

    'start with 1 word
    PickWord row%, col%, direction%, index%
    PlaceWord row%, col%, direction%, index%

    'add new words
    MakeXword

    'score and maybe save
    ScoreGrid words%, letters%, connections%
    runtime! = ClockRunTime!
    ShowStats "grid", statline%, try&, words%, letters%, connections%, runtime!
    SaveBestGrid try&, words%, letters%, connections%, runtime!

    'minimum grids are also interesting!
    SaveMinGrid try&, words%, letters%, connections%, runtime!
    
    'check options, some of these are NOT on the menu:
    '  x        single step
    '  m        show minimum grid
    '  r        randomize timer

    IF LEN(INKEY$) OR words% = maxword% THEN
      ClockStop
      SoundBeep
      ShowBestGrid
      BottomLine menu$
      DO
        DO: in$ = INKEY$: LOOP UNTIL LEN(in$)
        SELECT CASE UCASE$(in$)
          'quit or continue
          CASE "Q", esc$: done% = true: EXIT DO
          CASE " ", enter$: EXIT DO

          'run options
          CASE "D": displayflag% = NOT displayflag%: EXIT DO
          CASE "X": singlestep% = NOT singlestep%: EXIT DO
          CASE "R": RANDOMIZE TIMER

          'grid actions
          CASE "+"
            IF maxgrid% < maxgridsize THEN
              maxgrid% = maxgrid% + 1
              newgrid% = true
              EXIT DO
            ELSE
              SoundBop
            END IF
          CASE "-"
            IF maxgrid% > mingridsize THEN
              maxgrid% = maxgrid% - 1
              newgrid% = true
              EXIT DO
            ELSE
              SoundBop
            END IF
          CASE "G": InputGridSize: newgrid% = true: EXIT DO

          'file actions
          CASE "L": LoadGrid
          CASE "P": SaveGrid true
          CASE "S": SaveGrid false
          CASE "H": SaveHTML
          CASE "W"
            InputWordList tflag%
            IF tflag% THEN newwords% = true: EXIT DO
          CASE "M"
            ShowMinGrid
            DO: in$ = INKEY$: LOOP UNTIL LEN(in$)
            ShowBestGrid
            BottomLine menu$
          CASE "I"
            ShowInfo
            DO: in$ = INKEY$: LOOP UNTIL LEN(in$)
            ClearWindow
            ShowBestGrid
            BottomLine menu$

          'cursor actions
          CASE upkey$: ShowWordAdjust -1
          CASE downkey$: ShowWordAdjust 1
          CASE pgupkey$: ShowWordAdjust -8
          CASE pgdnkey$: ShowWordAdjust 8
          CASE homekey$: ShowWordAdjust -6666
          CASE endkey$: ShowWordAdjust 6666
          CASE rightkey$, leftkey$
            IF menu$ = rmenu$ THEN
              menu$ = lmenu$
            ELSE
              menu$ = rmenu$
            END IF
            BottomLine menu$
          CASE ELSE: SoundBop         'nada

        END SELECT
      LOOP

      IF NOT newgrid% THEN
        ShowStats "grid", statline%, try&, words%, letters%, connections%, runtime!
        ShowStats "best", bestline%, besttry&, bestwords%, bestletters%, bestconnections%, besttime!
      END IF

      'restart the clock
      ClockRestart

    END IF

    IF singlestep% THEN
      ClockStop
      in$ = UCASE$(INPUT$(1))
      ClockRestart
      IF in$ = esc$ OR in$ = "Q" THEN done% = true
      IF in$ = "X" THEN singlestep% = NOT singlestep%
    END IF
  
  LOOP UNTIL done% OR newgrid% OR newwords%

  'return reason for quitting
  'all of these will reset the clock
  ClockStop

  IF done% THEN
    flag% = doneflag
  ELSEIF newgrid% THEN
    flag% = gridflag
  ELSEIF newwords% THEN
    flag% = wordflag
  END IF

END SUB

